#ifndef _reporting_config_h
#define _reporting_config_h

#define MAX_NUM_ATTRIBUTES 8

typedef struct replication_ {
    char * server;
    char * password;
    char * mode;
    char * interval;
} replication_t;

typedef struct pbx_ {
    char * identifier;
} pbx_t;

typedef struct ldap_ {
    char *pbx;
    char *server;
    char *host;
    char *port;
    char *user;
    char *password;
    char *base;
    char *filter;
    char *nameattrib[MAX_NUM_ATTRIBUTES];
    char *numberattrib[MAX_NUM_ATTRIBUTES];
    char *active;
    char *cc;
    char *ac;
    char *np;
    char *ip;
    char *el;
    char *sn;
} ldap_t;

typedef struct ldap_servers_ {
    ldap_t **ldap;
    int num_ldap_servers;
} ldap_servers_t;

typedef struct config_ {
    char * error;
    replication_t *replication;
    pbx_t *pbx;
    ldap_servers_t *ldap_servers;
} config_t;

void cleanup_config(config_t * cfg);
void free_ldap_config(ldap_servers_t *ldap_servers);
config_t * read_config(PGconn * conn);
ldap_servers_t * read_ldap_config(PGconn *conn, pthread_mutex_t *mutex, ldap_servers_t **ldap_act);

#endif
