#!/bin/sh
#
# argument 1: 

trap "on_error $1; exit" INT QUIT TERM

function on_error() {
    rm -f $1
}

if [ "$1" == "" ]; then
    exit
fi

# check if running with argument $1
if [ -f "$1" ]; then
    # the lock file already exists, so what to do?
    if [ "$(ps -p `cat $1` | wc -l)" -lt 2 ]; then
        # process not running, but lock file not deleted?
        rm $1
    else
        # process running with same argument  
        exit
    fi        
fi

proc_arg="$1"
touch $proc_arg
if [ $? -ne 0 ]; then
    echo "ERROR: $(date '+%Y-%m-%d %H:%M:%S') - Can't create temp file $1, exiting..."
    exit 1
fi
echo $$ > $proc_arg

# call file
$2 $3

